c# redmap.f
      SUBROUTINE REDMAP2(MONTH)
C--------------------------------
C
C     THIS ROUTINE READS THE IONOSPHERIC LONG TERM DATA BASE FILE
c*****************************************************************
c     An error in the coefficient data file was corrected on 3.Nov.94
c     The values for SYS(9,2,6) & SYS(9,10,6) for SPRING & FALL were wrong.
c     They were 115.2 and should have been 11.52.
c     This required no programming change, but the comment was placed here
c     to record the error for posterity.  The change was corrected in the
c     ASCII data file and then it was converted to binary.
c*****************************************************************
C
ccc      common /crun_directory/ run_directory
ccc         character run_directory*50
C.....F1 LAYER MONTHLY COEFFICIENTS
      COMMON /FONE/ ANEW(3),BNEW(3),ACHI(2),BCHI(2)
C.....COEFFICIENTS FOR CRITICAL FREQUENCIES AND F2 LAYER HEIGHT OF
C.....MAXIMUM / SEMITHICKNESS RATIO
      COMMON /ONE/ IA(6),IB(6),IKIM(10,6),ESLCOF(5,55),ESMCOF(7,61),
     +             ESUCOF(5,55),F2COF(13,76),FM3COF(9,49),ERCOF(9,22)
ccc   COMMON / RAYS / ANG(40), IFOB(40,30,5), NANG
C  PROGRAM VERSION NUMBER, PROGRAM CONTROL VARIABLES
C.....NOISE COEFFICIENTS AND DISTRIBUTION TABLES
      COMMON /TWO/ F2D(16,6,6),
     +             FAKP(29,16,6),FAKMAP(29,16),HMYM(29,16),
     +             FAKABP(2,6),ABMAP(2,3),
     +             DUD(5,12,5),FAM(14,12),SYS(9,16,6),PERR(9,4,6)
C.....VARIABLES FROM THE DATA BASE FILE BEFORE SUNSPOT INTERPOLATION
      DIMENSION XESLCF(5,55,2), XESMCF(7,61,2), XESUCF(5,55,2),
     A XFM3CF(9,49,2),XERCOF(9,22,2),XF2COF(13,76,2),XPMAP(29,16,2)
C--------------------------------
      CHARACTER coeff_name*12
c*****************************************************************
ccc      nch_run=lcount(run_directory,50)
c*****************************************************************
c          read the rest of the coefficients
      write(coeff_name,'(5hcoeff,i2.2,5hw.bin)') MONTH
ccc      OPEN(27,FILE=run_directory(1:nch_run-3)//'coeffs\'//coeff_name,
      OPEN(27,FILE='coeffs\'//coeff_name,
     +       status='old',form='unformatted')
      rewind(27)
      READ(27,END=300,ERR=400) IKIM
      READ(27,END=300,ERR=400) FAKP,FAKABP
      READ(27,END=300,ERR=400) DUD,FAM,SYS
      READ(27,END=300,ERR=400) XFM3CF

      READ(27,END=300,ERR=400) F2D,PERR
      READ(27,END=300,ERR=400) ANEW,BNEW,ACHI,BCHI,FAKMAP,ABMAP
      READ(27,END=300,ERR=400) XESMCF,XPMAP
      READ(27,END=300,ERR=400) XESLCF,XESUCF
      READ(27,END=300,ERR=400) XERCOF
c*****************************************************************
ccc      SSN125=125.-SSN
ccc      SSN25=SSN-25.
ccc      DO 220 I=1,29
ccc      DO 220 J=1,16
ccc220   HMYM(I,J)=(XPMAP(I,J,1)*SSN125 + XPMAP(I,J,2)*SSN25)/100.
      GO TO 500
c*****************************************************************
300   PAUSE 'END OF FILE ON DATA BASE in REDMAP'
      GO TO 500
400   PAUSE 'ERROR ON DATA BASE READ in REDMAP'
500   CLOSE(27)
      RETURN
      END
C--------------------------------
