      subroutine contpl(nps,labl,nchlab,on,dlen)
c***********************************************************************
c          draw and label contour lines 
c 
c          (x,y)    = arrays of (x,y) points of line 
c          nps      = # of points in (x,y)
c          labl     = array containing label characters (2 per word)
c          nchlab   = # chars in label
c          on       = parameter to dashit describing line style
c          dlen     = parameter to dashit
c***********************************************************************
      common /proj/ iproj,plat,plon
      common /xyval/ x(5000),y(5000)
      character labl*(*)
      data ithick/2/
      if(iproj.eq.8) then          !  convert from lat/lon
         do 5 i=1,nps
         call supcon(y(i),x(i),u,v)
         x(i)=u
5        y(i)=v
      end if
      call charget(chxx,chyy) 
      ires=iresolut()
      call charworl(chx,chy)       !  get character size in world units
      size=chx*1.1 
      if(ires.le.-600) then
         chyy=chyy*1.2
         size=size*1.2
      end if
        nchar=nchlab  
        call rblankc(labl,nchar)
        call rzeros(labl,nchar)     !  remove trailing zeros that are not needed
c          locate label at center of line 
      len=lentext(labl(1:nchar))
        sizelab=float(len)*chx/chxx + size
c          find line length 
        xlen=0. 
        do 10 i=2,nps 
 10     xlen=xlen + sqrt((x(i)-x(i-1))**2 + (y(i)-y(i-1))**2) 
c******************************************************************
c          eliminate short lines (short=width of 1 character)
      if(xlen.lt.size) go to 150 
c******************************************************************
        hlen=xlen/2. 
        if(sizelab.lt.hlen/2.0) go to 40  
 15     call dashthic(x,y,nps,on,dlen,ithick)  
ccc 15     call thickl(x,y,nps,-1.,1.,.1)
        go to 150 
 40     hlen=hlen-sizelab/2.      
        xlen=0. 
        do 20 i=2,nps 
        dl=sqrt((x(i)-x(i-1))**2 + (y(i)-y(i-1))**2)
        xlen=xlen+dl
        if(xlen.gt.hlen) go to 30     
 20     continue
 30     xlen=xlen-dl
        frac=(hlen-xlen)/dl 
        xc=x(i-1) + (x(i)-x(i-1))*frac
        yc=y(i-1) + (y(i)-y(i-1))*frac
        ndex=i
        xsave=x(i)
        ysave=y(i)
        x(i)=xc
        y(i)=yc
	xc1=xc
	yc1=yc
        call dashthic(x,y,ndex,on,dlen,ithick)
ccc        call thickl(x,y,ndex,-1.,1.,.1)
        x(i)=xsave
        y(i)=ysave
c          find (xp,yp) such that dist (xc,yc)-(xp,yp) = sizelab
        do 50 i=ndex,nps
        dl=sqrt((x(i)-xc)**2 + (y(i)-yc)**2)
        if(dl.gt.sizelab) go to 60      
 50     continue
        go to 15
c          (xp,yp) is between (x(nn),y(nn)) & (x(nn+1),y(nn+1)) 
 60     nn=i
        x1=x(nn-1)
        y1=y(nn-1)
        x2=x(nn)
        y2=y(nn)
        do 70 i=1,15       
        xp=(x1+x2)/2. 
        yp=(y1+y2)/2. 
        d=sqrt((xp-xc)**2 + (yp-yc)**2) 
        if(d.lt.sizelab) go to 65 
        x2=xp 
        y2=yp 
        go to 70
 65     x1=xp 
        y1=yp 
 70     continue
        dx=xp-xc
        dy=yp-yc
        ang=atan2(dy,dx)/.0174533 
        fact=(nchar+1)*2
        dx=dx/fact
        dy=dy/fact
        if(ang.gt.90. .or. ang.lt.-90.) go to 80
        a=(ang-90.)*.0174533
        xc=xc+dx+cos(a)*size/2. 
        yc=yc+dy+sin(a)*size/2. 
        go to 90
 80     ang=ang+180.
        a=(ang-90.)*.0174533
        xc=xp-dx + cos(a)*size/2. 
        yc=yp-dy + sin(a)*size/2. 
90      continue
cc      call symbol(xc,yc,chx,chy,labl,ang,nchar)
        x(nn-1)=xp
        y(nn-1)=yp
c           draw the rest of the line
        call dashthic(x(nn-1),y(nn-1),nps-nn+2,on,dlen,ithick)
ccc        call thickl(x(nn-1),y(nn-1),nps-nn+2,-1.,1.,.1)
	xc=(xc1+xp)/2.
	yc=(yc1+yp)/2.
	call plotxy(xc,yc,u,v)
ccc        call plotabs(u-float(len)/2.,v+chyy/2.,3)
	call plotabs(u-float(len)/2.,v-chyy*3/4.,3)
	call textc(nchar,labl)
 150    return
        end 
c-----------------------------------------------------------------------
      subroutine thickit(ix1,iy1,ix2,iy2,ithick)
c          draws thick lines for dashthick & dashthicki
      call ploti(ix1,iy1,3)
      call ploti(ix2,iy2,2)
      return
      end
c-----------------------------------------------------------------------
      subroutine thickit_old(ix1,iy1,ix2,iy2,ithick)
c          draws thick lines for dashthick & dashthicki
      common /mdevice/ idev,ixoff,iyoff     !  =0=screen         =1=printer
      if(ithick.eq.0 .or. idev.ge.0) then
         call ploti(ix1,iy1,3)
         call ploti(ix2,iy2,2)
         return
      end if
      if(ix1.eq.ix2) go to 40
      slope=float(iy2-iy1)/float(ix2-ix1)
      if(ix2.gt.ix1) then
         do 10 ix=ix1,ix2
         jthick=ithick
         if(ix.eq.ix1 .or. ix.eq.ix2) jthick=1
         iy=slope*(float(ix-ix1)) + iy1 + .5
         call ploti(ix,iy-jthick,3)
10       call ploti(ix,iy+jthick,2)
      else
         do 20 ix=ix2,ix1
         jthick=ithick
         if(ix.eq.ix1 .or. ix.eq.ix2) jthick=1
         iy=slope*(float(ix-ix1)) + iy1 + .5
         call ploti(ix,iy-jthick,3)
20       call ploti(ix,iy+jthick,2)
      end if
40    if(iy1.eq.iy2) go to 80
      slope=float(ix2-ix1)/float(iy2-iy1)
      if(iy2.gt.iy1) then
         do 50 iy=iy1,iy2
         jthick=ithick
         if(iy.eq.iy1 .or. iy.eq.iy2) jthick=1
         ix=slope*(float(iy-iy1)) + ix1 + .5
         call ploti(ix-jthick,iy,3)
50       call ploti(ix+jthick,iy,2)
      else
         do 60 iy=iy2,iy1
         jthick=ithick
         if(iy.eq.iy1 .or. iy.eq.iy2) jthick=1
         ix=slope*(float(iy-iy1)) + ix1 + .5
         call ploti(ix-jthick,iy,3)
60       call ploti(ix+jthick,iy,2)
      end if
80    return
      end
c------------------------------------------------------------------
