      SUBROUTINE proj_inv(X,Y,RLONG,RLAT)   !  invert projection
      COMMON /AZEL/ ZTLAT,ZTLON,ZTHT,ZRLAT,ZRLON,ZRHT,ZTAZ,ZRAZ,
     +              ZTELV,ZRELV,ZD,ZDGC,ZTAKOF,ZRAKOF
      common /proj/ iproj,plat,plon
c**********************************************************************
c          special projection for GRIB format
c                    INTERNATIONAL EXCHANGE GRIDS
c                                  
c     VALUE  RESOLUTION      AREA              GRID          GRID
c            (degrees)     COVERAGE            SHAPE        POINTS
c            lon x lat     (degrees)        cols  rows
c   IPROJ
c     21    5.0 x 2.5   0-180E, 0-90N         37   36 + pole  1333
c     22    5.0 x 2.5   180W-0, 0-90N         37   36 + pole  1333
c     23    5.0 x 2.5   0-180E, 90S-0  pole + 37   36         1333
c     24    5.0 x 2.5   180W-0, 90S-0  pole + 37   36         1333
c*****NOTE:
c          to be consistent with MY area coverage files, the pole
c          is calculated and saved more than once.
c**********************************************************************
      IF(IPROJ.EQ.7) GO TO 70              !  GREAT CIRCLE PROJECTION
c          special projection for GRIB format
      rlong=x
      rlat =y
      go to 100
70    ZTLAT=PLAT                !  CENTER OF GREAT CIRCLE PROJECTION
      ZTLON=PLON
      if(x.ne.0. .or. y.ne.0.) then
         ZTAZ=90.-ATAN2(Y,X)/.0174533         !  AZIMUTH
         IF(ZTAZ.LT.0.) ZTAZ=ZTAZ+360.
         ZDGC=SQRT(X*X+Y*Y)                   !  GREAT CIRCLE DISTANCE
         ZTHT=0.       !  height of transmitter
         ZRHT=0.       !  height of receiver
         CALL DAZEL1
         RLONG=ZRLON
         RLAT=ZRLAT
      else
	 rlat=plat                         !  point is center of projection
	 rlong=plon
      end if
c          fix up RLONG so it is between 0 & 360.
      if(rlong.lt.0.) rlong=rlong+360.
100   if(abs(RLAT).gt.89.9) RLONG=0.    !  at poles, force long=0
      RETURN
      END
C------------------------------------------------------------------
