      integer*4 function printer_setup()
c         allow user to modify printer setup information
c         currently, things that can be modified are:
c            draw border around map (Yes or No)
c            reduce plot size
c            offset plot origin
      include <windows.ins>
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
      common /pSETUP/ x_draw_border,x_scale_factor,x_Xoffset,x_Yoffset
         integer*4 x_draw_border
         real*8 x_scale_factor,x_Xoffset,x_Yoffset
      external printer_setup_OK,printer_setup_NO,printer_setup_default
      character border(2)*20,WHITE*11
      data border/'Draw Border','Do Not Draw Border'/
      data WHITE/'%`bg[white]'/      !  make next field WHITE

      call r_setup                !  read window colors information
      call printer_setup_read     !  read values on ..\database\print.ini
      x_draw_border=draw_border
      x_scale_factor=scale_factor
      x_Xoffset=Xoffset
      x_Yoffset=Yoffset

      k=WINIO@('%ca[Change Area Coverage Printer SETUP information]&')
      call backgrnd         !  set the background color of the window 
      k=winio@('%`^tt[Accept]%^tt[Cancel]&',
     +         printer_setup_OK,printer_setup_NO)
      k=winio@('%^?tt[Default]'//
     +    '[Default (Draw Border, Scale=1.0, Offset=0,0)]&',
     +         printer_setup_default)

      A=WINIO@('%nl%nlBorder:   '//
     + WHITE//'%?lb@&',
     + border,2,x_draw_border,
     + 'Do you want a border drawn around the map?')

      A=WINIO@('%nl%nl%nlScale:     '//WHITE//
     + '%fl%?rf@&',
     +  0.D0,1.D0,x_scale_factor,
     + 'Relative size to scale output (Maximum=1.0)')

      A=WINIO@('%nl%nlX-offset: '//WHITE//
     + '%fl%?rf@ inches&',
     +  -10.D0,10.D0,x_Xoffset,
     + 'X origin offset')

      A=WINIO@('%nl%nlY-offset: '//WHITE//
     + '%fl%?rf@ inches&',
     +  -10.D0,10.D0,x_Yoffset,
     + 'Y origin offset')

      A=WINIO@('%nl%nl%nl%nl%obInput Help: %tc[red]%he%cb%nl%nl')
      printer_setup=1
      return
      end
c-----------------------------------------------------------------
      integer*4 function printer_setup_OK()
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
      common /pSETUP/ x_draw_border,x_scale_factor,x_Xoffset,x_Yoffset
         integer*4 x_draw_border
         real*8 x_scale_factor,x_Xoffset,x_Yoffset

      draw_border=x_draw_border
      if(x_scale_factor.le.0.) x_scale_factor=1.0
      scale_factor=x_scale_factor
      Xoffset=x_Xoffset
      Yoffset=x_Yoffset
      if(scale_factor.ge..99) then
         Xoffset=0.
         Yoffset=0.
      end if
      call printer_setup_save     !  save values on ..\database\setup.ini
      printer_setup_OK=0
      return
      end
c-----------------------------------------------------------------
      integer*4 function printer_setup_NO()
      printer_setup_NO=0
      return
      end
c-----------------------------------------------------------------
      integer*4 function printer_setup_default()
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
      draw_border=1     !  yes
      scale_factor=1.0
      Xoffset=0.
      Yoffset=0.
      call printer_setup_save     !  save values on ..\database\setup.ini
      printer_setup_default=0
      return
      end
c-----------------------------------------------------------------
      subroutine printer_setup_save     !  save values on ..\database\print.ini
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
ccc      common /crun_directory/ run_directory
ccc         character run_directory*50
ccc      nch_run=lcount(run_directory,50)

ccc      open(21,file=run_directory(1:nch_run)//'\print_a.ini')
      open(21,file='print_a.ini')
      rewind(21)
      write(21,1) draw_border,scale_factor,Xoffset,Yoffset
1     format(i5,3f10.4)
      close(21)
      return
      end
c-----------------------------------------------------------------
      subroutine printer_setup_read     !  read values on ..\database\print.ini
      common /c_printer_setup/ draw_border,scale_factor,Xoffset,Yoffset
         integer*4 draw_border      !  1=yes, 2=no
         real*4 scale_factor,Xoffset,Yoffset
ccc      common /crun_directory/ run_directory
ccc         character run_directory*50
ccc      nch_run=lcount(run_directory,50)

ccc      open(21,file=run_directory(1:nch_run)//'\print_a.ini',
      open(21,file='print_a.ini',
     +     status='old',err=100)
      rewind(21)
      read(21,1) draw_border,scale_factor,Xoffset,Yoffset
1     format(i5,3f10.4)
      close(21)
      return
100   draw_border=1     !  yes
      scale_factor=1.0
      Xoffset=0.
      Yoffset=0.
      return
      end
c-----------------------------------------------------------------
