      subroutine WORLD(XXMIN,XXMAX,YYMIN,YYMAX,NSTEP,mask,iproj)
C******************************************************************
C          NSTEP = # increments between data points.
C                    1=every data point.
C                    2=every other data point.
C                    etc.
c          mask = type of data to display
c               =  0 = all
c               =  1 = 'B' - country boundaries
c               =  2 = 'C' - coastlines
c               =  4 = 'I' - islands
c               =  8 = 'L' - lakes
c               = 16 = 'Y' - ?
c               = 32 = 'U' - USA state boundaries
c                 use logical combinations (i.e. 3='B'+'C')
C******************************************************************
ccc      common /crun_directory/ run_directory
ccc         character run_directory*50
      COMMON /WORDL3/ XMN(2),XMX(2),YMN(2),YMX(2),nwind,NSKIP
      character bcil*1,bcila(16)*1
      dimension x(1000),y(1000)
      data bcila/'B','C',' ','I',3*' ','L',7*' ','Y'/
      DATA NR/10/               !  MAX # POINTS IN a BUFFER
C
ccc      nch_run=lcount(run_directory,50)
ccc      if(mask.ge.32) then
cccc          Plot USA state boundaries
ccc         call usa(xxmin,xxmax,yymin,yymax,iproj)
ccc         return
ccc      end if
      NSKIP=NSTEP               !  DATA POINT LOOP STEP
      IF(NSKIP.LE.0) NSKIP=1    !  MUST BE > 0
ccc      write(39,'(" nstep,nskip=",2i5)') nstep,nskip
      XMN(1)=XXMIN
      XMX(1)=XXMAX
      YMN(1)=YYMIN
      YMX(1)=YYMAX
      nwind=1
      if(xmn(1).ge.180.) xmn(1)=xmn(1)-360.
      if(xmx(1).gt.180.) xmx(1)=xmx(1)-360.
      if(xmn(1).gt.xmx(1)) then
          xmx(2)=xmx(1)
          xmx(1)=180.
          xmn(2)=-180.
          ymn(2)=ymn(1)
          ymx(2)=ymx(1)
          nwind=2
      end if
ccc      write(15,'(''iproj='',2i5)') iproj,nskip
ccc      do 5 i=1,nwind
ccc5     write(15,6) i,xmn(i),xmx(i),ymn(i),ymx(i)
ccc6     format(' wind=',i2,4f10.4)
      LUD=31
ccc      OPEN(LUD,FILE=run_directory(1:nch_run-3)//'DATABASE\world.idx',
      OPEN(LUD,FILE='DATABASE\world.idx',
     +     form='unformatted',
     +     access='direct',status='old',recl=32,iostat=ios,err=900)
      read(lud,rec=1) nrecs      !  read number of records in file
ccc      OPEN(LUD+1,FILE=run_directory(1:nch_run-3)//'DATABASE\world.dat',
      OPEN(LUD+1,FILE='DATABASE\world.dat',
     +     form='unformatted',
     +     access='direct',STATUS='OLD',RECL=nr*8,IOSTAT=IOS,ERR=910)
      do 200 ir=1,nrecs
      READ(LUD,rec=ir+1) xmin,xmax,ymin,ymax,npts,irec,linecode,icode
ccc      write(15,14) xmin,xmax,ymin,ymax,npts,irec
ccc14    format('line=',4f10.4,2i8)
      bcil=bcila(icode)
      if(mask.eq.0) go to 15               !  all codes
      if(iand(icode,mask).eq.0) go to 200  !  ignore this type
15    if(npts.le.nskip) then
          if(bcil.eq.'L' .or. bcil.eq.'I') go to 200
      end if
      if(iproj.eq.8) go to 30
      do 20 iw=1,nwind
      IF(YMAX.LT.YMN(iw) .OR. YMIN.GT.YMX(iw)) GO TO 20 ! OUTSIDE WINDOW
      IF(XMAX.LT.XMN(iw) .OR. XMIN.GT.XMX(iw)) GO TO 20 ! OUTSIDE WINDOW
      go to 30                  !  inside window
20    continue
      go to 200                 !  outside all windows

30    do 50 i=1,npts,nr         !  read coordinates
      irec=irec+1
      k=i+nr-1
      if(k.gt.npts) k=npts
50    read(lud+1,rec=irec) (x(j),y(j),j=i,k)
ccc      write(15,51) iw,linecode,bcil,npts,xmin,xmax,ymin,ymax
ccc51    format(i2,1h=,i10,a1,i4,4f10.5)
ccc      write(15,52) (x(i),y(i),i=1,npts)
ccc52    format(8f10.5)
ccc      if(iproj.eq.8) call setw(xmn(iw),ymn(iw),xmx(iw),ymx(iw))
      CALL DCHAIN(x,y,npts,iw)  !  DRAW PART OF CHAIN
200   continue
      CLOSE(LUD)                !  NO MORE CHAINS TO PLOT
      close(lud+1)
      RETURN
900   WRITE(*,901) IOS,'DATABASE\world.idx'
901   FORMAT(' OPEN ERROR in WORLD =',I6,' on file=',a)
      STOP 'OPEN error on world.idx'
910   WRITE(*,901) IOS,'DATABASE\world.dat'
      STOP 'OPEN error on world.dat'
      END
C------------------------------------------------------------------
      subroutine DCHAIN(x,y,n,iw)
C          DRAW THE CHAIN OF (LAT,LON) POINTS
      COMMON /WORDL3/ XMN(2),XMX(2),YMN(2),YMX(2),nwind,NSKIP
      dimension x(*),y(*)
      ipen=3
      DO 10 I=1,N
      IF(I.EQ.N) GO TO 5
      IF(((I-1)/NSKIP)*NSKIP.NE.I-1) GO TO 10
5     XX=x(i)
      YY=y(i)
c     IF(XX.LT.XMN(iw) .OR. XX.GT.XMX(iw)) GO TO 9      !  OUTSIDE WINDOW
c     IF(YY.LT.YMN(iw) .OR. YY.GT.YMX(iw)) GO TO 9      !  OUTSIDE WINDOW
ccc      write(15,'(2f10.4,i3)') xx,yy,ipen
      CALL PLOTLL(XX,YY,IPEN)
      IPEN=2
      GO TO 10
9     IPEN=3
10    CONTINUE
      RETURN
      END
C------------------------------------------------------------------
      subroutine PLOTLL(XLON,YLAT,JPEN)
      COMMON /MINMAX/ UMIN,UMAX,VMIN,VMAX
      COMMON /BLOK2/ UEPS,VEPS,UOLD,VOLD,CROSS
      DATA ULAST,VLAST/-99999.,-99999./
      IPEN=JPEN
      CALL SUPCON(YLAT,XLON,U,V)
      IF(U.LT.UMIN) UMIN=U
      IF(U.GT.UMAX) UMAX=U
      IF(V.LT.VMIN) VMIN=V
      IF(V.GT.VMAX) VMAX=V
      IF(IPEN.EQ.3) GO TO 10
      IF(ABS(U-ULAST).GT.UEPS .OR. ABS(V-VLAST).GT.VEPS) IPEN=3
10    CALL PLOT(U,V,IPEN)
ccc      write(15,11) xlon,ylat,u,v,ipen,ueps,veps
ccc11    format('plotll=',4f10.4,i3,2f10.4)
      ULAST=U
      VLAST=V
      RETURN
      END
C--------------------------------------------------------------------
